%define _version 	1.0.1
%define _patchlevel	p6
%define _release	11

Name: torque
Version: %{_version}%{_patchlevel}
Release: %{_release}%{disttag}%{repotag}
License: OpenPBS (Portable Batch System) v2.3 Software License
URL: http://www.supercluster.org/projects/torque/

Packager: Karsten Petersen <kapet@hrz.tu-chemnitz.de>

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: tcl libtool autoconf automake tclx tcl-devel tk-devel

# this is the Torque source archive, it is based on OpenPBS 2.3.12
# and already contains several patches, including the official ones
Source: %{name}-%{version}.tar.gz

# new buildsystem
Source5: torque-1.0.1p6-autotools-files_to_remove_before.txt
Source6: torque-1.0.1p6-autotools.tar.gz

# init.d scripts
Source10: pbs_server.init
Source11: pbs_mom.init
Source12: pbs_sched.init
Source13: pbs.sysconfig

Patch0:   torque-1.0.1p6-transient-tmpdir.patch
# bugfixes
#Patch0: filename.patch

# extend functionality
#Patch10: spbs-1.0.1p2-mpiexec.patch
#Patch11: spbs-1.0.1p2-moddata.patch

# base package
Summary: Tera-scale Open-source Resource and QUEue manager (Torque)
Group: System Environment/Resource Management
Provides: OpenPBS, spbs, PBS, pbs, openpbs

%package clients
Summary: Torque - Command line tools
Group: System Environment/Resource Management
Requires: %{name} = %{version}-%{release}


%package gui
Summary: Torque - GUI tools
Group: System Environment/Resource Management
Requires: %{name}-clients = %{version}-%{release}

%package resmom
Summary: Torque - MOM daemon
Group: System Environment/Resource Management
Requires: %{name} = %{version}-%{release}
PreReq: chkconfig

%package server
Summary: Torque - Server
Group: System Environment/Resource Management
Requires: %{name} = %{version}-%{release}
PreReq: chkconfig

%package scheduler.cc.fifo
Summary: Torque - Standard FIFO scheduler
Group: System Environment/Resource Management
Requires: %{name}-server = %{version}-%{release}
PreReq: chkconfig

%package devel
Summary: Torque - Development environment
Group: System Environment/Resource Management
Requires: %{name} = %{version}-%{release}
Provides: OpenPBS-devel, spbs-devel

%description
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is an improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains basic information about Torque and prepares elementary
filesystem structures.  You will need it if you want to use Torque.

%description clients
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains the basic command line tools - if you want to
use Torque, you will have to install it!

%description gui
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains the xpbs and xpbsmon X11-GUI tools.  But they
are somewhat outdated and hard to configure and use.  You can easily
live without them.

%description server
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains the central server daemon of Torque.
It is responsible for managing the queues, communication with the
MOMs and handling user requests.  You need this package only on
server machines.

%description resmom
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains the MOM daemon of Torque.  It is a mini-server that
manages a slave machine.  You will need this on all machines that should
be used by Torque to run jobs on.

%description scheduler.cc.fifo
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

Although a server receives job requests from users, it does not put
them into execution.  This is the task of the scheduler, and this
package contains a "simple" FIFO-style scheduler.  Install this on the
server machine if you do not have a special scheduler.

%description devel
OpenPBS is a resource manager providing control over batch jobs and
distributed compute nodes.  Torque is a improved version of OpenPBS and
incorporates scalability, fault tolerance, and feature extension patches
provided by NCSA, OSC, Sandia, PNNL, U of Buffalo, and other leading edge
HPC centers.  This version is based upon OpenPBS version 2.3.12 and may
be freely redistributed.

This package contains include files and static libraries of Torque.
Install it, if you want to build some software that extends Torque.

%prep
# the real thing
%setup -q

# new buildsystem
for filename in `/bin/cat %{SOURCE5}` ; do
	/bin/rm $filename
done
%setup -q -T -D -a6


# bugfixes
#%patch0 -p1

# extend functionality
#%patch10 -p1
#%patch11 -p1

# create buildsystem
if [ "x%{disttag}" = "x.rh7.3" -o "x%{disttag}" = "x.rhel2.1" ] ; then
	libtoolize --force --copy
	aclocal-1.5
	autoheader-2.53 
	automake-1.5 --foreign --add-missing --force-missing --copy
	autoconf-2.53
else
	libtoolize --force --copy
	aclocal
	autoheader
	automake --foreign --add-missing --force-missing --copy
	autoconf
fi

# Apply torque-1.0.1p6-transient-tmpdir.patch
%patch0 -p1



%build
#%ifarch ia64
#  # without this, the library won't be linkable by some 3rd party tools
#  CFLAGS="${CFLAGS:-%optflags} -fPIC" ; export CFLAGS
#%endif

CFLAGS="-DTRANSIENT_TMPDIR=1"
export CFLAGS


%configure --disable-dependency-tracking \
           --with-server-home=/var/spool/pbs \
	   --with-server-name-file=/var/spool/pbs/server_name \
           --with-tmpdir=/var/spool/pbs \
	   --with-default-server=localhost \
	   --with-qstatrc-file=/etc/pbs/qstatrc \
	   --with-scp \
	   --enable-tcl-qstat

#	--enable-module-support \
#	--enable-module-login-control \
#	--enable-module-pag-tools \
#	--enable-module-afs-token \
#	--enable-module-afs-token-gpg \
#	--enable-module-uwtmp \
#	--enable-module-sac-table \
#	--set-module-config-file=/etc/pbs/pbs_modules.conf \
#	--with-krb5 \
#	--with-krbafs \
#	--with-afs

# these two directories do not like parallel makes
cd doc
make
cd ..

cd src/include
make
cd ../..

# main make - parallel if possible
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install-strip DESTDIR=%{buildroot}

%__cp     src/lib/Libnet/.libs/libnet.a %{buildroot}%{_libdir}/libnet.a
%__cp     src/lib/Libnet/.libs/libnet.la %{buildroot}%{_libdir}/libnet.la
# Install start up scripts.
%__mkdir -p             %{buildroot}%{_sysconfdir}/init.d
%__cp    -f %{SOURCE10} %{buildroot}%{_sysconfdir}/init.d/pbs_server
%__cp    -f %{SOURCE11} %{buildroot}%{_sysconfdir}/init.d/pbs_mom
%__cp    -f %{SOURCE12} %{buildroot}%{_sysconfdir}/init.d/pbs_sched
%__mkdir -p             %{buildroot}%{_sysconfdir}/sysconfig
%__cp    -f %{SOURCE13} %{buildroot}%{_sysconfdir}/sysconfig/pbs

# remove unneccessary files:
#   basl scheduler
rm %{buildroot}%{_mandir}/man1/basl2c.1*
rm %{buildroot}%{_mandir}/man8/pbs_sched_basl.8*
#   tcl scheduler
rm %{buildroot}%{_mandir}/man8/pbs_sched_tcl.8*

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc PBS_License.text Read.Me README.torque Release_Notes CHANGELOG README.RPM
%doc doc/admin_guide.ps contrib/README.pbs_python contrib/README.pam_authuser
%doc %{_mandir}/man1/pbs.1*
%doc %{_mandir}/man7/pbs_job_attributes.7*
%doc %{_mandir}/man7/pbs_queue_attributes.7*
%doc %{_mandir}/man7/pbs_resources.7*
%doc %{_mandir}/man7/pbs_resources_aix4.7*
%doc %{_mandir}/man7/pbs_resources_digitalunix.7*
%doc %{_mandir}/man7/pbs_resources_freebsd.7*
%doc %{_mandir}/man7/pbs_resources_fujitsu.7*
%doc %{_mandir}/man7/pbs_resources_hpux10.7*
%doc %{_mandir}/man7/pbs_resources_irix5.7*
%doc %{_mandir}/man7/pbs_resources_irix6.7*
%doc %{_mandir}/man7/pbs_resources_irix6array.7*
%doc %{_mandir}/man7/pbs_resources_linux.7*
%doc %{_mandir}/man7/pbs_resources_netbsd.7*
%doc %{_mandir}/man7/pbs_resources_solaris5.7*
%doc %{_mandir}/man7/pbs_resources_solaris7.7*
%doc %{_mandir}/man7/pbs_resources_sp2.7*
%doc %{_mandir}/man7/pbs_resources_sunos4.7*
%doc %{_mandir}/man7/pbs_resources_unicos8.7*
%doc %{_mandir}/man7/pbs_resources_unicosmk2.7*
%doc %{_mandir}/man7/pbs_server_attributes.7*
%dir /var/spool/pbs
%dir /var/spool/pbs/aux
%dir /var/spool/pbs/spool
%config(noreplace) /var/spool/pbs/pbs_environment
%config(noreplace) /etc/sysconfig/pbs

%files clients
%defattr(-,root,root)
%config(noreplace) /var/spool/pbs/server_name
/usr/bin/chk_tree
/usr/bin/hostn
/usr/bin/nqs2pbs
/usr/bin/pbsdsh
/usr/bin/pbsnodes
/usr/bin/pbs_tclsh
/usr/bin/printjob
/usr/bin/qalter
/usr/bin/qdel
/usr/bin/qdisable
/usr/bin/qenable
/usr/bin/qhold
/usr/bin/qmgr
/usr/bin/qmove
/usr/bin/qmsg
/usr/bin/qorder
/usr/bin/qrerun
/usr/bin/qrls
/usr/bin/qrun
/usr/bin/qselect
/usr/bin/qsig
/usr/bin/qstart
/usr/bin/qstat
/usr/bin/qstop
/usr/bin/qsub
/usr/bin/qterm
/usr/bin/tracejob
/usr/sbin/pbs_demux
/usr/sbin/pbs_iff
%doc %{_mandir}/man1/nqs2pbs.1*
%doc %{_mandir}/man1/pbsdsh.1*
%doc %{_mandir}/man1/qalter.1*
%doc %{_mandir}/man1/qdel.1*
%doc %{_mandir}/man1/qhold.1*
%doc %{_mandir}/man1/qmove.1*
%doc %{_mandir}/man1/qmsg.1*
%doc %{_mandir}/man1/qorder.1*
%doc %{_mandir}/man1/qrerun.1*
%doc %{_mandir}/man1/qrls.1*
%doc %{_mandir}/man1/qselect.1*
%doc %{_mandir}/man1/qsig.1*
%doc %{_mandir}/man1/qstat.1*
%doc %{_mandir}/man1/qsub.1*
%doc %{_mandir}/man8/pbsnodes.8*
%doc %{_mandir}/man8/qdisable.8*
%doc %{_mandir}/man8/qenable.8*
%doc %{_mandir}/man8/qmgr.8*
%doc %{_mandir}/man8/qrun.8*
%doc %{_mandir}/man8/qstart.8*
%doc %{_mandir}/man8/qstop.8*
%doc %{_mandir}/man8/qterm.8*

%files gui
%defattr(-,root,root)
/usr/bin/pbs_wish
/usr/bin/xpbs
/usr/bin/xpbsmon
%dir %{_libdir}/xpbs
%{_libdir}/xpbs/*
%dir %{_libdir}/xpbsmon
%{_libdir}/xpbsmon/*
%doc %{_mandir}/man1/xpbs.1*
%doc %{_mandir}/man1/xpbsmon.1*

%files resmom
%defattr(-,root,root)
/usr/sbin/pbs_mom
/usr/sbin/pbs_rcp
%attr(0755,root,root) /etc/init.d/pbs_mom
%dir /var/spool/pbs/checkpoint
%dir /var/spool/pbs/mom_logs
%dir /var/spool/pbs/mom_priv
%dir /var/spool/pbs/mom_priv/jobs
%dir /var/spool/pbs/undelivered
%doc %{_mandir}/man8/pbs_mom.8*


%files server
%defattr(-,root,root)
/usr/sbin/pbs_server
%attr(0755,root,root) /etc/init.d/pbs_server
%dir /var/spool/pbs/server_logs
%dir /var/spool/pbs/server_priv
%dir /var/spool/pbs/server_priv/accounting
%dir /var/spool/pbs/server_priv/acl_groups
%dir /var/spool/pbs/server_priv/acl_hosts
%dir /var/spool/pbs/server_priv/acl_svr
%dir /var/spool/pbs/server_priv/acl_users
%dir /var/spool/pbs/server_priv/jobs
%dir /var/spool/pbs/server_priv/queues
%dir /var/spool/pbs/sched_logs
%dir /var/spool/pbs/sched_priv
%doc %{_mandir}/man8/pbs_server.8*

%files scheduler.cc.fifo
%defattr(-,root,root)
/usr/sbin/pbs_sched
%attr(0755,root,root) /etc/init.d/pbs_sched
%config(noreplace) /var/spool/pbs/sched_priv/dedicated_time
%config(noreplace) /var/spool/pbs/sched_priv/holidays
%config(noreplace) /var/spool/pbs/sched_priv/resource_group
%config(noreplace) /var/spool/pbs/sched_priv/sched_config
%doc %{_mandir}/man8/pbs_sched_cc.8*

%files devel
%defattr(-,root,root)
/usr/include/pbs_error.h
/usr/include/pbs_ifl.h
/usr/include/rpp.h
/usr/include/tm_.h
/usr/include/tm.h
%{_libdir}/libpbs.a
%{_libdir}/libpbs.la
%{_libdir}/libnet.la
%{_libdir}/libnet.a
%doc %{_mandir}/man3/pbs_alterjob.3*
%doc %{_mandir}/man3/pbs_connect.3*
%doc %{_mandir}/man3/pbs_default.3*
%doc %{_mandir}/man3/pbs_deljob.3*
%doc %{_mandir}/man3/pbs_disconnect.3*
%doc %{_mandir}/man3/pbs_geterrmsg.3*
%doc %{_mandir}/man3/pbs_holdjob.3*
%doc %{_mandir}/man3/pbs_locate.3*
%doc %{_mandir}/man3/pbs_manager.3*
%doc %{_mandir}/man3/pbs_movejob.3*
%doc %{_mandir}/man3/pbs_msgjob.3*
%doc %{_mandir}/man3/pbs_orderjob.3*
%doc %{_mandir}/man3/pbs_rerunjob.3*
%doc %{_mandir}/man3/pbs_rescquery.3*
%doc %{_mandir}/man3/pbs_rescreserve.3*
%doc %{_mandir}/man3/pbs_rlsjob.3*
%doc %{_mandir}/man3/pbs_runjob.3*
%doc %{_mandir}/man3/pbs_selectjob.3*
%doc %{_mandir}/man3/pbs_selstat.3*
%doc %{_mandir}/man3/pbs_sigjob.3*
%doc %{_mandir}/man3/pbs_stagein.3*
%doc %{_mandir}/man3/pbs_statjob.3*
%doc %{_mandir}/man3/pbs_statnode.3*
%doc %{_mandir}/man3/pbs_statque.3*
%doc %{_mandir}/man3/pbs_statserver.3*
%doc %{_mandir}/man3/pbs_submit.3*
%doc %{_mandir}/man3/pbs_terminate.3*
%doc %{_mandir}/man3/rpp.3*
%doc %{_mandir}/man3/tm.3*

%post resmom
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add pbs_mom
  /sbin/chkconfig pbs_mom on
else
  /sbin/chkconfig pbs_mom reset
  /sbin/service pbs_mom condrestart
fi

%preun resmom
if [ "$1" = 0 ] ; then
   /sbin/service pbs_mom stop
   /sbin/chkconfig --del pbs_mom
fi

%post server
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add pbs_server
  /sbin/chkconfig pbs_server on
else
  /sbin/chkconfig pbs_server reset
  /sbin/service pbs_server condrestart
fi

%preun server
if [ "$1" = 0 ] ; then
   /sbin/service pbs_server stop
   /sbin/chkconfig --del pbs_server
fi

%post scheduler.cc.fifo
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add pbs_sched
  /sbin/chkconfig pbs_sched on
else
  /sbin/chkconfig pbs_sched reset
  /sbin/service pbs_sched condrestart
fi

%preun scheduler.cc.fifo
if [ "$1" = 0 ] ; then
   /sbin/service pbs_sched stop
   /sbin/chkconfig --del pbs_sched
fi


%changelog
* Mon Aug 2  2004 Steve Traylen <s.traylen@rl.ac.uk>
- Bump release.
- Fix for transient dir patch from David.
* Thu Jul 22 2004 Steve Traylen <s.traylen@rl.ac.uk>
- Hopefully correct this time.
- Activate TMPDIR.
* Thu Jun 17 2004 Steve Traylen <s.traylen@rl.ac.uk>
- Bump release to 5.
- Add David Groep's torque-1.0.1p6-transient-tmpdir.patch patch.

* Mon May 17 2004 Steve Traylen <s.traylen@rl.ac.uk>
- Added init.d scripts for pbs_mom, pbs_server and pbs_sched.

* Thu Apr 07 2004 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- Torque 1.0.1p6

* Thu Feb 05 2004 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- renamed to Tera-scale Open-source Resource and QUEue manager (Torque)
- Torque 1.0.1p4

* Mon Jan 19 2004 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- renamed to Scalable Open Resource Manager (StORM)
- StORM 1.0.1p3

* Mon Dec 11 2003 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- Scalable PBS 1.0.1p2

* Mon Nov 17 2003 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- Scalable PBS 1.0.1p0
- initial inclusion of new autoconf/automake stuff

* Mon Oct 20 2003 Karsten Petersen <kapet@hrz.tu-chemnitz.de>
- Initial version with Scalable OpenPBS 1.0.0p5.
  (Several ideas taken from spec-files by Mike Becher and Erwan Velu.)

